﻿using System.Diagnostics;
using System.Drawing;
using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;
using Infragistics.Win.UltraWinEditors;
using System;
using System.Windows.Forms;

namespace UltraGridBUPrototype
{
    public class CreatingUiElement : IUIElementCreationFilter
    {
        public static UltraGrid grid;
        public void AfterCreateChildElements(UIElement parent)
        {
            DependentTextUIElement Del = parent as DependentTextUIElement;

            if (Del != null && Del.Text.Length < 4)
            {

                UltraCheckEditor ed = new UltraCheckEditor();
                ed.Parent = Del.Control;
                ed.Text = "Check it";
                ed.Height = 15;
                ed.Appearance.BackColor = Color.Gainsboro;
                ed.Location = new Point(Del.Rect.X + 35, Del.Rect.Y);
                ed.Width = 75;
                ed.AfterCheckStateChanged += new CheckEditor.AfterCheckStateChangedHandler(ed_AfterCheckStateChanged);
            }

            foreach (Control cnt in grid.Controls)
            {
                DependentTextUIElement UI = grid.DisplayLayout.UIElement.ElementFromPoint(cnt.Location) as DependentTextUIElement;
                if (cnt.GetType() == typeof(UltraCheckEditor) && UI == null)
                {
                    grid.Controls.Remove(cnt);
                }
            }
        }

        void ed_AfterCheckStateChanged(object sender, EventArgs e)
        {
            UltraCheckEditor editor = sender as UltraCheckEditor;
            if (editor == null) return;

            foreach (UltraGridRow it in grid.Rows)
            {
                DependentTextUIElement UI = grid.DisplayLayout.UIElement.ElementFromPoint(editor.Location) as DependentTextUIElement;
                foreach (UltraGridRow rr in it.ChildBands[0].Rows.All)
                {
                    if (rr.IsGroupByRow && rr.Description == UI.Text)
                    {
                        foreach (UltraGridRow row in it.ChildBands[0].Rows[rr.Index].ChildBands[0].Rows.All)
                        {
                          row.Cells[0].Value = editor.Checked;
                        }
                    }
                }
            }
        }
   
        public bool BeforeCreateChildElements(UIElement parent)
        {
            return false;
        }
    }
}